3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|*' --va'*)
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
50 my $ok = join("|", qw(
59 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
60 print join("\n", @vars);
62 GIT_AUTHOR_EMAIL=author@example.com
63 GIT_AUTHOR_NAME='A U Thor'
64 GIT_COMMITTER_EMAIL=committer@example.com
65 GIT_COMMITTER_NAME='C O Mitter'
68 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
69 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
70 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
73 # Protect ourselves from common misconfiguration to export
74 # CDPATH into the environment
79 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
81 echo "* warning: Some tests will not work if GIT_TRACE" \
82 "is set as to trace on STDERR ! *"
83 echo "* warning: Please set GIT_TRACE to something" \
84 "other than 1, 2 or true ! *"
90 # A regexp to match 5 and 40 hexdigits
91 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
92 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
95 _z40=0000000000000000000000000000000000000000
101 # Each test should start with something like this, after copyright notices:
103 # test_description='Description of this test...
104 # This test checks if command xyzzy does the right thing...
107 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
108 TERM=$ORIGINAL_TERM &&
111 tput bold >/dev/null 2>&1 &&
112 tput setaf 1 >/dev/null 2>&1 &&
113 tput sgr0 >/dev/null 2>&1
117 while test "$#" -ne 0
120 -d|--d|--de|--deb|--debu|--debug)
122 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
123 immediate=t; shift ;;
124 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
125 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
126 -h|--h|--he|--hel|--help)
128 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
130 -q|--q|--qu|--qui|--quie|--quiet)
131 # Ignore --quiet under a TAP::Harness. Saying how many tests
132 # passed without the ok/not ok details is always an error.
133 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
135 with_dashes=t; shift ;;
138 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139 valgrind=t; verbose=t; shift ;;
141 shift ;; # was handled already
143 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
146 echo "error: unknown test option '$1'" >&2; exit 1 ;;
150 if test -n "$color"; then
156 error) tput bold; tput setaf 1;; # bold red
157 skip) tput bold; tput setaf 2;; # bold green
158 pass) tput setaf 2;; # green
159 info) tput setaf 3;; # brown
160 *) test -n "$quiet" && return;;
170 test -z "$1" && test -n "$quiet" && return
177 say_color error "error: $*"
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
189 if test "$help" = "t"
191 echo "$test_description"
197 if test "$verbose" = "t"
201 exec 4>/dev/null 3>/dev/null
210 test_external_has_tap=0
214 if test -n "$GIT_EXIT_OK"
218 echo >&5 "FATAL: Unexpected exit with code $code"
226 # The semantics of the editor variables are that of invoking
227 # sh -c "$EDITOR \"$@\"" files ...
229 # If our trash directory contains shell metacharacters, they will be
230 # interpreted if we just set $EDITOR directly, so do a little dance with
231 # environment variables to work around this.
233 # In particular, quoting isn't enough, as the path may contain the same quote
238 EDITOR='"$FAKE_EDITOR"'
242 test_decode_color () {
245 if (n == 0) return "RESET";
246 if (n == 1) return "BOLD";
247 if (n == 30) return "BLACK";
248 if (n == 31) return "RED";
249 if (n == 32) return "GREEN";
250 if (n == 33) return "YELLOW";
251 if (n == 34) return "BLUE";
252 if (n == 35) return "MAGENTA";
253 if (n == 36) return "CYAN";
254 if (n == 37) return "WHITE";
255 if (n == 40) return "BLACK";
256 if (n == 41) return "BRED";
257 if (n == 42) return "BGREEN";
258 if (n == 43) return "BYELLOW";
259 if (n == 44) return "BBLUE";
260 if (n == 45) return "BMAGENTA";
261 if (n == 46) return "BCYAN";
262 if (n == 47) return "BWHITE";
265 while (match($0, /\033\[[0-9;]*m/) != 0) {
266 printf "%s<", substr($0, 1, RSTART-1);
267 codes = substr($0, RSTART+2, RLENGTH-3);
268 if (length(codes) == 0)
271 n = split(codes, ary, ";");
273 for (i = 1; i <= n; i++) {
274 printf "%s%s", sep, name(ary[i]);
279 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
303 sed -e 's/$/Q/' | tr Q '\015'
307 tr '\015' Q | sed -e 's/Q$//'
310 # In some bourne shell implementations, the "unset" builtin returns
311 # nonzero status when a variable to be unset was not set in the first
314 # Use sane_unset when that should not be considered an error.
322 if test -z "${test_tick+set}"
326 test_tick=$(($test_tick + 60))
328 GIT_COMMITTER_DATE="$test_tick -0700"
329 GIT_AUTHOR_DATE="$test_tick -0700"
330 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
333 # Stop execution and start a shell. This is useful for debugging tests and
334 # only makes sense together with "-v".
336 # Be sure to remove all invocations of this command before submitting.
339 if test "$verbose" = t; then
340 "$SHELL_PATH" <&6 >&3 2>&4
342 error >&5 "test_pause requires --verbose"
346 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
348 # This will commit a file with the given contents and the given commit
349 # message. It will also add a tag with <message> as name.
351 # Both <file> and <contents> default to <message>.
355 echo "${3-$1}" > "$file" &&
358 git commit -m "$1" &&
362 # Call test_merge with the arguments "<message> <commit>", where <commit>
363 # can be a tag pointing to the commit-to-merge.
367 git merge -m "$1" "$2" &&
371 # This function helps systems where core.filemode=false is set.
372 # Use it instead of plain 'chmod +x' to set or unset the executable bit
373 # of a file in the working directory and add it to the index.
377 git update-index --add "--chmod=$@"
380 # Unset a configuration variable, but don't fail if it doesn't exist.
382 git config --unset-all "$@"
384 case "$config_status" in
385 5) # ok, nothing to unset
389 return $config_status
392 # Set git config, automatically unsetting it after the test is over.
394 test_when_finished "test_unconfig '$1'" &&
398 test_config_global () {
399 test_when_finished "test_unconfig --global '$1'" &&
400 git config --global "$@"
403 # Use test_set_prereq to tell that a particular prerequisite is available.
404 # The prerequisite can later be checked for in two ways:
406 # - Explicitly using test_have_prereq.
408 # - Implicitly by specifying the prerequisite tag in the calls to
409 # test_expect_{success,failure,code}.
411 # The single parameter is the prerequisite tag (a simple word, in all
412 # capital letters by convention).
415 satisfied="$satisfied$1 "
419 test_have_prereq () {
420 # prerequisites can be concatenated with ','
432 total_prereq=$(($total_prereq + 1))
435 ok_prereq=$(($ok_prereq + 1))
438 # Keep a list of missing prerequisites
439 if test -z "$missing_prereq"
441 missing_prereq=$prerequisite
443 missing_prereq="$prerequisite,$missing_prereq"
448 test $total_prereq = $ok_prereq
451 test_declared_prereq () {
452 case ",$test_prereq," in
460 # You are not expected to call test_ok_ and test_failure_ directly, use
461 # the text_expect_* functions instead.
464 test_success=$(($test_success + 1))
465 say_color "" "ok $test_count - $@"
469 test_failure=$(($test_failure + 1))
470 say_color error "not ok - $test_count $1"
472 echo "$@" | sed -e 's/^/# /'
473 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
476 test_known_broken_ok_ () {
477 test_fixed=$(($test_fixed+1))
478 say_color "" "ok $test_count - $@ # TODO known breakage"
481 test_known_broken_failure_ () {
482 test_broken=$(($test_broken+1))
483 say_color skip "not ok $test_count - $@ # TODO known breakage"
487 test "$debug" = "" || eval "$1"
491 # This is a separate function because some tests use
492 # "return" to end a test_expect_success block early.
493 eval </dev/null >&3 2>&4 "$*"
502 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
504 test_eval_ "$test_cleanup"
506 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
513 test_count=$(($test_count+1))
515 for skp in $GIT_SKIP_TESTS
517 case $this_test.$test_count in
523 if test -z "$to_skip" && test -n "$test_prereq" &&
524 ! test_have_prereq "$test_prereq"
531 if test "$missing_prereq" != "$test_prereq"
533 of_prereq=" of $test_prereq"
536 say_color skip >&3 "skipping test: $@"
537 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
546 test_expect_failure () {
547 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
549 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
553 say >&3 "checking known breakage: $2"
554 if test_run_ "$2" expecting_failure
556 test_known_broken_ok_ "$1"
558 test_known_broken_failure_ "$1"
564 test_expect_success () {
565 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
567 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
571 say >&3 "expecting success: $2"
582 # test_external runs external test scripts that provide continuous
583 # test output about their progress, and succeeds/fails on
584 # zero/non-zero exit code. It outputs the test output on stdout even
585 # in non-verbose mode, and announces the external script with "# run
586 # <n>: ..." before running it. When providing relative paths, keep in
587 # mind that all scripts run in "trash directory".
588 # Usage: test_external description command arguments...
589 # Example: test_external 'Perl API' perl ../path/to/test.pl
591 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
593 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
597 if ! test_skip "$descr" "$@"
599 # Announce the script to reduce confusion about the
600 # test output that follows.
601 say_color "" "# run $test_count: $descr ($*)"
602 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
603 # to be able to use them in script
604 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
605 # Run command; redirect its stderr to &4 as in
606 # test_run_, but keep its stdout on our stdout even in
611 if test $test_external_has_tap -eq 0; then
614 say_color "" "# test_external test $descr was ok"
615 test_success=$(($test_success + 1))
618 if test $test_external_has_tap -eq 0; then
619 test_failure_ "$descr" "$@"
621 say_color error "# test_external test $descr failed: $@"
622 test_failure=$(($test_failure + 1))
628 # Like test_external, but in addition tests that the command generated
629 # no output on stderr.
630 test_external_without_stderr () {
631 # The temporary file has no (and must have no) security
634 stderr="$tmp/git-external-stderr.$$.tmp"
635 test_external "$@" 4> "$stderr"
636 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
637 descr="no stderr: $1"
639 say >&3 "# expecting no stderr from previous command"
640 if [ ! -s "$stderr" ]; then
643 if test $test_external_has_tap -eq 0; then
646 say_color "" "# test_external_without_stderr test $descr was ok"
647 test_success=$(($test_success + 1))
650 if [ "$verbose" = t ]; then
651 output=`echo; echo "# Stderr is:"; cat "$stderr"`
655 # rm first in case test_failure exits.
657 if test $test_external_has_tap -eq 0; then
658 test_failure_ "$descr" "$@" "$output"
660 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
661 test_failure=$(($test_failure + 1))
666 # debugging-friendly alternatives to "test [-f|-d|-e]"
667 # The commands test the existence or non-existence of $1. $2 can be
668 # given to provide a more precise diagnosis.
669 test_path_is_file () {
672 echo "File $1 doesn't exist. $*"
677 test_path_is_dir () {
680 echo "Directory $1 doesn't exist. $*"
685 test_path_is_missing () {
690 if [ $# -ge 1 ]; then
697 # test_line_count checks that a file has the number of lines it
698 # ought to. For example:
700 # test_expect_success 'produce exactly one line of output' '
701 # do something >output &&
702 # test_line_count = 1 output
705 # is like "test $(wc -l <output) = 1" except that it passes the
706 # output through when the number of lines is wrong.
711 error "bug in the test script: not 3 parameters to test_line_count"
712 elif ! test $(wc -l <"$3") "$1" "$2"
714 echo "test_line_count: line count for $3 !$1 $2"
720 # This is not among top-level (test_expect_success | test_expect_failure)
721 # but is a prefix that can be used in the test script, like:
723 # test_expect_success 'complain and die' '
725 # do something else &&
726 # test_must_fail git checkout ../outerspace
729 # Writing this as "! git checkout ../outerspace" is wrong, because
730 # the failure could be due to a segv. We want a controlled failure.
735 if test $exit_code = 0; then
736 echo >&2 "test_must_fail: command succeeded: $*"
738 elif test $exit_code -gt 129 -a $exit_code -le 192; then
739 echo >&2 "test_must_fail: died by signal: $*"
741 elif test $exit_code = 127; then
742 echo >&2 "test_must_fail: command not found: $*"
748 # Similar to test_must_fail, but tolerates success, too. This is
749 # meant to be used in contexts like:
751 # test_expect_success 'some command works without configuration' '
752 # test_might_fail git config --unset all.configuration &&
756 # Writing "git config --unset all.configuration || :" would be wrong,
757 # because we want to notice if it fails due to segv.
762 if test $exit_code -gt 129 -a $exit_code -le 192; then
763 echo >&2 "test_might_fail: died by signal: $*"
765 elif test $exit_code = 127; then
766 echo >&2 "test_might_fail: command not found: $*"
772 # Similar to test_must_fail and test_might_fail, but check that a
773 # given command exited with a given exit code. Meant to be used as:
775 # test_expect_success 'Merge with d/f conflicts' '
776 # test_expect_code 1 git merge "merge msg" B master
779 test_expect_code () {
784 if test $exit_code = $want_code
789 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
793 # test_cmp is a helper function to compare actual and expected output.
794 # You can use it like:
796 # test_expect_success 'foo works' '
797 # echo expected >expected &&
799 # test_cmp expected actual
802 # This could be written as either "cmp" or "diff -u", but:
803 # - cmp's output is not nearly as easy to read as diff -u
804 # - not all diff versions understand "-u"
810 # This function can be used to schedule some commands to be run
811 # unconditionally at the end of the test to restore sanity:
813 # test_expect_success 'test core.capslock' '
814 # git config core.capslock true &&
815 # test_when_finished "git config --unset core.capslock" &&
819 # That would be roughly equivalent to
821 # test_expect_success 'test core.capslock' '
822 # git config core.capslock true &&
824 # git config --unset core.capslock
827 # except that the greeting and config --unset must both succeed for
830 # Note that under --immediate mode, no clean-up is done to help diagnose
833 test_when_finished () {
835 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
838 # Most tests can use the created repository, but some may need to create more.
839 # Usage: test_create_repo <directory>
840 test_create_repo () {
842 error "bug in the test script: not 1 parameter to test-create-repo"
846 cd "$repo" || error "Cannot setup test environment"
847 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
848 error "cannot run git init -- have you built things yet?"
849 mv .git/hooks .git/hooks-disabled
856 if test -z "$HARNESS_ACTIVE"; then
857 test_results_dir="$TEST_DIRECTORY/test-results"
858 mkdir -p "$test_results_dir"
859 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
861 cat >>"$test_results_path" <<-EOF
863 success $test_success
871 if test "$test_fixed" != 0
873 say_color pass "# fixed $test_fixed known breakage(s)"
875 if test "$test_broken" != 0
877 say_color error "# still have $test_broken known breakage(s)"
878 msg="remaining $(($test_count-$test_broken)) test(s)"
880 msg="$test_count test(s)"
882 case "$test_failure" in
884 # Maybe print SKIP message
885 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
887 if test $test_external_has_tap -eq 0; then
888 say_color pass "# passed all $msg"
889 say "1..$test_count$skip_all"
892 test -d "$remove_trash" &&
893 cd "$(dirname "$remove_trash")" &&
894 rm -rf "$(basename "$remove_trash")"
899 if test $test_external_has_tap -eq 0; then
900 say_color error "# failed $test_failure among $msg"
909 # Test the binaries we have just built. The tests are kept in
910 # t/ subdirectory and are run in 'trash directory' subdirectory.
911 if test -z "$TEST_DIRECTORY"
913 # We allow tests to override this, in case they want to run tests
914 # outside of t/, e.g. for running tests on the test library
916 TEST_DIRECTORY=$(pwd)
918 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
920 if test -n "$valgrind"
924 test "$1" = "$(readlink "$2")" || {
932 while test -d "$2".lock
934 say "Waiting for lock on $2."
941 make_valgrind_symlink () {
942 # handle only executables, unless they are shell libraries that
943 # need to be in the exec-path. We will just use "#!" as a
944 # guess for a shell-script, since we have no idea what the user
945 # may have configured as the shell path.
947 test "#!" = "$(head -c 2 <"$1")" ||
950 base=$(basename "$1")
951 symlink_target=$GIT_BUILD_DIR/$base
952 # do not override scripts
953 if test -x "$symlink_target" &&
954 test ! -d "$symlink_target" &&
955 test "#!" != "$(head -c 2 < "$symlink_target")"
957 symlink_target=../valgrind.sh
961 symlink_target=../unprocessed-script
963 # create the link, or replace it if it is out of date
964 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
967 # override all git executables in TEST_DIRECTORY/..
968 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
969 mkdir -p "$GIT_VALGRIND"/bin
970 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
972 make_valgrind_symlink $file
974 # special-case the mergetools loadables
975 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
980 ls "$path"/git-* 2> /dev/null |
983 make_valgrind_symlink "$file"
987 PATH=$GIT_VALGRIND/bin:$PATH
988 GIT_EXEC_PATH=$GIT_VALGRIND/bin
990 elif test -n "$GIT_TEST_INSTALLED" ; then
991 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
992 error "Cannot run git from $GIT_TEST_INSTALLED."
993 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
994 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
995 else # normal case, use ../bin-wrappers only unless $with_dashes:
996 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
997 if ! test -x "$git_bin_dir/git" ; then
998 if test -z "$with_dashes" ; then
999 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1003 PATH="$git_bin_dir:$PATH"
1004 GIT_EXEC_PATH=$GIT_BUILD_DIR
1005 if test -n "$with_dashes" ; then
1006 PATH="$GIT_BUILD_DIR:$PATH"
1009 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1011 GIT_CONFIG_NOSYSTEM=1
1013 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1015 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1017 if test -z "$GIT_TEST_CMP"
1019 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1021 GIT_TEST_CMP="$DIFF -c"
1023 GIT_TEST_CMP="$DIFF -u"
1027 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1029 test -d "$GIT_BUILD_DIR"/templates/blt || {
1030 error "You haven't built things yet, have you?"
1033 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1035 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1037 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1038 error "You haven't built git_remote_helpers yet, have you?"
1042 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1043 echo >&2 'You need to build test-chmtime:'
1044 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1049 test="trash directory.$(basename "$0" .sh)"
1050 test -n "$root" && test="$root/$test"
1052 /*) TRASH_DIRECTORY="$test" ;;
1053 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1055 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1058 echo >&5 "FATAL: Cannot prepare test area"
1062 HOME="$TRASH_DIRECTORY"
1065 test_create_repo "$test"
1066 # Use -P to resolve symlinks in our working directory so that the cwd
1067 # in subprocesses like git equals our $PWD (for pathname comparisons).
1068 cd -P "$test" || exit 1
1071 this_test=${this_test%%-*}
1072 for skp in $GIT_SKIP_TESTS
1074 case "$this_test" in
1076 say_color skip >&3 "skipping test $this_test altogether"
1077 skip_all="skip all tests in $this_test"
1082 # Provide an implementation of the 'yes' utility
1097 # Fix some commands on Windows
1100 # Windows has its own (incompatible) sort and find
1110 # git sees Windows-style pwd
1114 # no POSIX permissions
1115 # backslashes in pathspec are converted to '/'
1116 # exec does not inherit the PID
1117 test_set_prereq MINGW
1118 test_set_prereq SED_STRIPS_CR
1121 test_set_prereq POSIXPERM
1122 test_set_prereq EXECKEEPSPID
1123 test_set_prereq NOT_MINGW
1124 test_set_prereq SED_STRIPS_CR
1127 test_set_prereq POSIXPERM
1128 test_set_prereq BSLASHPSPEC
1129 test_set_prereq EXECKEEPSPID
1130 test_set_prereq NOT_MINGW
1134 test -z "$NO_PERL" && test_set_prereq PERL
1135 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1136 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1137 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1139 # Can we rely on git's output in the C locale?
1140 if test -n "$GETTEXT_POISON"
1142 GIT_GETTEXT_POISON=YesPlease
1143 export GIT_GETTEXT_POISON
1144 test_set_prereq GETTEXT_POISON
1146 test_set_prereq C_LOCALE_OUTPUT
1149 # Use this instead of test_cmp to compare files that contain expected and
1150 # actual output from git commands that can be translated. When running
1151 # under GETTEXT_POISON this pretends that the command produced expected
1154 test -n "$GETTEXT_POISON" || test_cmp "$@"
1157 # Use this instead of "grep expected-string actual" to see if the
1158 # output from a git command that can be translated either contains an
1159 # expected string, or does not contain an unwanted one. When running
1160 # under GETTEXT_POISON this pretends that the command produced expected
1163 if test -n "$GETTEXT_POISON"
1166 elif test "x!" = "x$1"
1175 # test whether the filesystem supports symbolic links
1176 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1179 # When the tests are run as root, permission tests will report that
1180 # things are writable when they shouldn't be.
1181 test -w / || test_set_prereq SANITY